#include <iostream>
#include <cstdio>
#include <cstring>

using namespace std;

const int NMAX=1000000, MAXWORDS=10000;

int but[256]; //but[c] - кнопка, на которой нанесена буква c
int nwords; //количество слов в словаре
int words[MAXWORDS], wlens[MAXWORDS]; //коды слов и их длины
//код (номер) - то, что получается при наборе слова кнопками

bool codes[NMAX][7]; //codes[i][j] - можно ли получить код i длиной j
//длина используется для различения кодов вида 01 и 001
const int ccnt[6]={1,10,100,1000,10000,100000}; 

int main() {
//   freopen("mnemonic.in","r",stdin);
//   freopen("mnemonic.out","w",stdout);
   
   //считываем буквы на кнопках
   for (int i=0; i<10; i++) {
      char buf[30]; int k; char s[27]="";
      gets(buf);
      sscanf(buf,"%d %s",&k, s);
      for (char *c=s; *c!=0; c++) but[*c]=i;
   }
   cin >> nwords;
   
   //считываем слова, сразу переводим в коды и запоминаем в массиве words
   for (int i=0; i<nwords; i++){
      char w[7];
      cin >> w;
      //получаем код слова w
      int code=0, wlen=strlen(w);
      for (char *c=w; *c!=0; c++)
         code = code*10 + but[*c];         
      words[i] = code;
      wlens[i] = wlen;
   }

   //ДП. Перебираем длину телефонного номера
   for (int clen=1; clen<=6; clen++) {
      //берём код каждого слова и пытаемся дописать к предыдущим кодам
      for (int i=0; i<nwords; i++) {
         if (wlens[i]>clen) continue;
         if (wlens[i]==clen) {
            codes[ words[i] ] [clen] = true; 
            continue;
         }
         int prev_len = clen - wlens[i]; //код какой длины должен стоять слева
         //перебираем коды длины prev_len, дописываем справа word[i] и запоминаем
         for(int j=0; j<ccnt[prev_len]; j++){
            //строим новый код
            if (codes[j][prev_len]){
               int code = j * ccnt[wlens[i] ] + words[i];
               codes[code][clen] = true;
            }
         }

      }
   }
   
   //смотрим, сколько номеров у нас получилось
   int ans=0;
   for (int i=0; i<1000000; i++)
      if (codes[i][6])
         ans++;         

   cout << ans << endl;

   return 0;
}
